Parker Prospect #1 @9964
Fri Apr 20 15:17:16 1990
      +---------------------------------------------------------+
      +         Basic Message Quoting Mod (BASQUOT.MOD)         +
      +---------------------------------------------------------+

I live in a small town, with relatively few BBSes (total number = 5).
Four of those are IBM BBSes, and one is SearchLight.  I am quite taken
with SearchLight, and love its editor to death.  One of the features in
this editor is the ability to "Get reply text".  What this does is you
press two keys (^KG) and the message you are replying to appears in the
editor, with quote characters '>' on the beginning of each line.  I
decided I wanted to do this, but it wouldn't be of real use unless you
could delete the unwanted lines.  Hence, the full-screen editor
restriction on quoting messages here (you need one in order to be able
to edit it).  This works both locally and remotely, as long as the user
support a full screen editor.  I have asked Black Dragon to help me with
a better version, so hopefully that will come in soon, and maybe Wayne
will take a notion to put in into the next version of WWIV.

------------------------------------------------------------------------
Step #1 <MSGBASE1.C>: In void scan, replace the case 'W', in its
                      entirety, with the one listed below.

              case 'W':
                deleted_flag = 0;
                if (s[0] == 'W') {
                  if (thisuser.defed != 0) {
                    prt(2, "Quote from message? ");
                    if (yn()) {
                      if ((msgnum > 0) && (msgnum <= nummsgs)) {
                        b = readfile(&(msgs[msgnum].msg),
                            (subboards[curlsub].filename),&len);
                        write_out_to_msg(b,len);
                      }
                      load_workspace("OUTPUT.MSG", 0);
                      unlink("OUTPUT.MSG");
                    }
                  }
                }
                post();
                if (deleted_flag && (deleted_flag<=msgnum))
                  --msgnum;
                break;


------------------------------------------------------------------------
Step #2 <MSGBASE1.C>: Add the following function BEFORE void scan.

void write_out_to_msg(char *b, long len)
{
  char s2[81];
  int i;

  sprintf(s2, "OUTPUT.MSG", syscfg.tempdir);
  i=open(s2,O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
  write(i,(void *)b,len);
  close(i);
  farfree(b);
}


------------------------------------------------------------------------
Final Step

Compile the BBS and update your menus to reflect the changes you made...


------------------------------------------------------------------------
Disclaimer

I, Jeff Garzik, claim no liability for this mod, or for any damage that
may have resulted from the use of this mod.  I also attach no warranty,
expressed OR implied, to this product.  This type of warranty and
liability disclaimer is prohibited by law in certain states, and is
therefore void in those states.

Two things:

1) When quoting ANSI pictures, the quoted message 4will not0 be displayed
correctly.

2) It may be smart to set the "-l" directive rather high, in INIT.EXE, because
some messages are long, and need to be cut short.  I personally don't care how
long my user's messages are, but it is a matter of personal taste and opinion.
