/* ELRIC11.MOD */
/* Print out BBS stats about the system, V1.1 */
/* Written by Lord Elric AKA Wayne McDaniel */
/* WWIVNet 1@8251 */
/* Thanks to The Black Dragon for some clues on file opening/closing/reading.
   I am not a C programmer(yet), but this is mostly original code. You
   are free to use/modify/distribute this however you desire, as long as
   you leave the credits alone though, except to add your own. */

#include <stdio.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include "vardec.h"

float totage;
int numusers,males,females;
int comp[10];
int speed[5];
int age1,age2,age3,age4;
char sysname[51];
int configfile,dirsfile,gamesfile,gfilesfile,subsfile;
configrec syscfg;



main()
{ char userfile[81];
  FILE *outfile;
  int f,i;
  unsigned int loop,num=0;
  unsigned long len;
  userrec user;
  char line[81],s[81];

  configfile=-1;
  strcpy(s,"CONFIG.DAT");
  configfile=open(s,O_RDWR | O_BINARY);
  if (configfile<0) {
    printf("%s NOT FOUND.\n",s);
    printf("This program must be run from the main BBS directory");
    exit(0);
    }
  read(configfile,(void *) (&syscfg), sizeof(configrec));
  close(configfile);


  sprintf(userfile,"%sUSER.LST",syscfg.datadir);
/* initialize some vars here */
  for (i=0;i<10;i++) {comp[i]=0;}
  males=0;   females=0;   age1=0;  age2=0;  age3=0;  age4=0;
  if ((f=open(userfile,O_RDWR|O_BINARY,S_IREAD|S_IWRITE))<=0) {
    printf("\nCould not open user list %s\n",userfile);
    abort();}
/** line below may be changed to create file directly in proper directory **/
  if ((outfile=fopen("GFILES\\BBSSTAT.TXT","w"))<=0) {
    printf("\nCould not open statistics file %s\n",userfile);
    abort(); }
  len=filelength(f);
  num=(len/sizeof(userrec))+!(len%sizeof(userrec));
  numusers=0;
  totage=0;
  for (loop=0;loop<num;loop++){
    if (sizeof(userrec)==read(f,&user,sizeof(userrec))){
    printf("\015Processing user #%u of %u",loop,(num-1));
    if (loop>0){
    if (!(user.inact)) {
    numusers++;
    comp[user.comp_type]+=1;
    if (user.sex=='M')
      males++;
    else
      females+=1;
    totage=totage+user.age;
    if (user.age<14)
      age1++;
    else
      if (user.age<19)
	age2++;
      else
	if (user.age<22)
	  age3++;
	else
	  age4++;  }  } }}
  sprintf(line,"System user statistics\n----------------------\n\n");
  fputs(line,outfile);
  sprintf(line,"Number of Users  %i\n",numusers);
  fputs(line,outfile);
  sprintf(line,"Males  %4i                             Females  %4i\n",
  males,females);
  fputs(line,outfile);
  fputs("\n\n\n",outfile);
  sprintf(line,"Age of Users\n------------\n");
  fputs(line,outfile);
  sprintf(line,"Number of users under 14  %4d          Users 14 to 18  %4d\n",
	  age1,age2);
  fputs(line,outfile);
  sprintf(line,"          Users 19 to 21  %4d          Users over  21  %4d\n",
	  age3,age4);
  fputs(line,outfile);
  sprintf(line,"  Average age of users  %5.2f",(totage/numusers));
  fputs(line,outfile);
  fputs("\n\n\n",outfile);
  sprintf(line,"Computers Represented\n---------------------\n");
  fputs(line,outfile);
  sprintf(line,"IBM XT/8088  %4d    IBM AT/80286  %4d    IBM 80386   %4d\n",
  comp[0],comp[1],comp[2]);
  fputs(line,outfile);
  sprintf(line,"IBM PS/2     %4d    Apple//s      %4d    Macintosh   %4d\n",
  comp[3],comp[4],comp[5]);
  fputs(line,outfile);
  sprintf(line,"Amiga        %4d    Commodore     %4d\n",comp[6],comp[7]);
  fputs(line,outfile);
  sprintf(line,"Atari        %4d    Other         %4d\n",comp[8],comp[9]);
  fputs(line,outfile);
  sprintf(line,"Total IBM users    %4d",comp[0]+comp[1]+comp[2]+comp[3]);
  fputs(line,outfile); 
 close(f);
  fclose(outfile);}
