Untouchable #1 @9804
Thursday, January 3, 1991  -  5:00 Pm
		-=CHATCCMD.MOD  (Chat Mode Command Mod)=-
		      -=Command Keys in Chat Mode=-

		     By Untouchable (WWIVnet: 1@9804)
		       Written for WWIV v4.11/v4.12

The concept of this mod comes from the chat mode in a Telegard (yuk)
BBS.  Telegard (yuk) has these cute little commands which you can
use in chat mode that give you a bit more control.  These thingies
were like /BYE to logoff, /TYPE ... to type a filename in DOS, Etc.
This mod will implement similar commands in the WWIV chat mode.
There is a small catch - you can only use the commands in standard
one way chat mode (I never cared for two way chat much anyway).
I'm sure it could be modded for two way chat, but I don't use it,
so I don't want to bother adding them to it.

This mod will add the following commands:

/end: Ends chat mode
/off: Logs off the system (Like '/O')
/cls: Clears the screen (Like '//CLS')
/view: Views a text file in DOS

[Users can also type '/help' to be given a menu]

On with the mod...

======================================================================
STEP ONE: Ugh, do you really need it?  BACK UP YOUR SOURCE CODE!

STEP TWO: At the top of CONIO.C, at the end of the externs, add
          the line:

extern void viewfile();

STEP THREE: In CONIO.C, insert the following code additions:

#ifdef TWO_WAY                                  /* Existing Code */
    if (two_way)                                /* Existing Code */
      two_way_chat(s,s1,160,1);                 /* Existing Code */
    else                                        /* Existing Code */
#endif                                          /* Existing Code */
      inli(s,s1,160,1);                         /* Existing Code */
      if (s[0]=='/') {                          /* Add This Line */
	if (strcmp(s,"/help")==0)               /* Add This Line */
	    printfile("CHATMENU");              /* Add This Line */
	if (strcmp(s,"/cls")==0)                /* Add This Line */
	    outchr(12);                         /* Add This Line */
	if (strcmp(s,"/view")==0)               /* Add This Line */
	    viewfile();                         /* Add This Line */
	if (strcmp(s,"/end")==0)                /* Add This Line */
	    chatting = 0;                       /* Add This Line */
	if (strcmp(s,"/off")==0) {              /* Add This Line */
	    chatting = 0;                       /* Add This Line */
	    hangup = 1;                         /* Add This Line */
	}                                       /* Add This Line */
      }                                         /* Add This Line */
    if ((chat_file) && (!two_way)) {            /* Existing Code */


### NOTE: The commands above (^^^) must be in lowercase - chat mode is
	  case sensitive, and if you put them in uppercase, the commands
	  will be activated by uppercase type only.  (This way it's
	  activated by lowercase, but who types in caps anymore?)
	  If you just want to be on the safe side, just change all
	  of the "strcmp" statements to look like this:
	  if ((strcmp(s,"/command")==0) || (strcmp(s,"/COMMAND")==0))
	  That way, it will accept either one.

STEP FOUR: Block read in this void at the end of CONIO.C (that's where I
           have it, because that's where it's called, but you could put
           it just about anywhere):
         
void viewfile()     /* When called, prompts for path\filename.ext to */
{                   /* view, in DOS, and is abortable with spacebar. */
	char filename[51];
	messagerec m;
	int next;

	nl(); nl();
	prt(2,"Filename to view: ");
	mpl(50);
	input(filename,50);

	m.stored_as=0L;
	m.storage_type=255;
	next=0;
	read_message1(&m,0,0,&next,filename);
}


STEP FIVE: Create a file called CHATMENU.MSG in your Gfiles directory,
	   and add the commands to them so your users know what they
	   are.  Or if you're lazy you can just block write the
	   description I've given above to the file.

And then you're done!  Pretty easy, huh?
======================================================================
If there are any problems with this mod, you can send me WWIVnet mail
to 1@9804, or if you REALLY want to jack up your phone bill, you can
call my BBS:

		  The King's Crown - (908) 238-4193 @9804
		  300/1200/2400/9600 Baud (V.32)
		  Auto-Sysop Validation
		  124 Megs - 15 Megs of WWIV files
		  (WWIV Registration 10730)

Thanks!

	--Untouchable, 1@9804.
