/*DirPrint.c */
/* Elric20.zip*/
/*
   This program prints out the transfer directory list in what will
 hopefully be a useful format.
 This program was written by Lord Elric, 1@8251

If you use this, the only payment I ask is that you send me a
note through WWIVNet to 1@8251 saying you are using it...not too much to
ask is it?

If you have any problems, you can reach me through WWIV-Net, 1@8251, or call
my BBS.
The Kingdom of Melnibone
812-877-3488  24 Hrs a day
3/12/2400/4800/9600/12,000/14,400 baud HST MNP5
Auto-validation of WWIV sysops on first call
Xmodem, Ymodem, DSZ Zmodem with retry, Ymodem-G

Lord Elric
*/


#include <io.h>
#include <stdio.h>
#include <fcntl.h>
#include "vardec.h"

int configfile,dirsfile;
FILE *printer;
int num_dirs;
directoryrec dirs[64];
directoryrec dir;
configrec syscfg;
int i,j,ls;
char s[81],s2[3];



void main()
{
  char s3[80],ch;



  configfile=-1;
  strcpy(s,"CONFIG.DAT");
  configfile=open(s,O_RDWR | O_BINARY);
  if (configfile<0) {
    printf("%s NOT FOUND.\n",s);
    exit(0);
    }
  read(configfile,(void *) (&syscfg), sizeof(configrec));
  close(configfile);

  dirsfile=-1;
  strcpy(s,syscfg.datadir);
  strcat(s,"DIRS.DAT");
  dirsfile=open(s,O_RDWR | O_BINARY);
  if (dirsfile<0) {
  printf("%s NOT FOUND.\n",s);
    exit(0);
    }
  num_dirs=(read(dirsfile,(void *) (&dirs), (64*sizeof(directoryrec))))/
             sizeof(directoryrec);
  close(dirsfile);

  printf("Welcome to Dir Print.\n");
  printf("Written By Lord Elric AKA Wayne McDaniel\n");
  printf("This program is for use with WWIV 4.xx\n");
  printf("Please contact Lord Elric, 1@8251 WWIVNet, with any problems\n");
  printf("Or call The Kingdom Of Melnibone BBS, 1-812-877-3488\n");
  printf("This is officially Elric's Mod #20\n\n");
  printf("Please enter the name of the file\n");
  printf("you wish to send this report to. Hit Return for printer.\n");
  printf("?");
  gets(s3);
  if (s3[0]==0)
    strcpy(s3,"prn");
  printer=fopen(s3,"w");
  if (printer==NULL) {
  printf("Cannot access printer\n");
    exit(0);
    }


  sprintf(s,"Transfer Directory listing for %s\n\n",syscfg.systemname);
  fputs(s,printer);

  fputs("Base  SL  DAR  Name                                      Age  MaxFiles\n",printer);


  for (i=0;i<num_dirs;i++)
   {
     dir=dirs[i];
/*here's where we print things out! */

     s2[0]=0;
     if (dir.dar!=0) {
      for (j=0; j<16; j++)
	if ((1 << j) & dir.dar)
	  s2[0]='A'+j;
      s2[1]=0;}
     sprintf(s," %2d  %3d   %1s   %-40s   %2d    %3d\n",
		i+1,dir.dsl,s2,dir.name,dir.age,dir.maxfiles);
     fputs(s,printer);
   }

  fputs("\f",printer);
  fclose(printer);
  }