Goose #1 @7312
Thu Jul 19 11:52:55 1990
                       Download while Scanning Files Mod          (DLSCAN.MOD)
                          by Goose, 1@7312 (WWIVnet)

This mod is basically a take off of the option in Forum boards that allow a
user to download or add files to the batch queue while performing a new scan
of the files section.  If the user has the option set, when scanning for new
files everytime the screen fills they are given the option of continuing,
aborting, or downloading.  Continue and abort should be self-explanatory,
however, if the user selects download he is given a prompt for the files he
wants to download.  These can then be either downloaded immediately or added
to the batch queue for downloading after the scan is complete.  What it does is
saves the user the effort of trying to remember the file names, or writing them
down, or scanning multiple times, etc.

The first part of this mod is basically the same as Buddy Cook's MANYFILE.MOD,
with a couple of changes I had made.  This mod allows the user to specify
multiple file names on the download file name line, rather than just the
normal one, with spaces or commas used as a delimiter between the file names.
If you have his mod in, go ahead and skip to the next section, else load up
XFER.C and make the following changes in void download(), where - indicates
existing code and + new/modifed code:

void download()
{
  char s[81],s1[81],s2[81];                                /* mod - change */
  int dn,i,i1,i2,abort;                                    /* mod - change */

  nl();
  pl("\x03""2Download - Enter Filename(s), Wildcards OK"); /* mod - change */
  nl();
  outstr(":");                                             /* mod - add */
  mpl(78);                                                 /* mod - add */
  input(s1,78);                                            /* mod - change */
  if (s1[0]==0)                                            /* mod - change */
    return;
  /* mod - delete prt(2,"Filename: "); */
  abort=0;                                                 /* mod - add */
  for (i=0; (i<=strlen(s1) && (!abort)); i++) {            /* mod - add */
    for (i2=0; i2<12; i2++)                                /* mod - add */
      s[i2]=0;                                             /* mod - add */
    i1=0;                                                  /* mod - add */
    while ((s1[i] != 32) && (s1[i] != 44))                 /* mod - add */
       s[i1++]=s1[i++];                                    /* mod - add */
    if (s[0]==0)                                           /* mod - add */
      continue;                                            /* mod - add */
    if (strchr(s,'.')==NULL)
      strcat(s,".*");
    align(s);
    i2=try_to_download(s,udir[curdir].subnum,0);           /* mod - change */
    if (i2==-1)                                            /* mod - add */
      abort=1;                                             /* mod - add */
    else                                                   /* mod - add */
    if (!i2) {                                             /* mod - add */
      nl();
      sprintf(s2,"Searching for %s ...",s);                /* mod - add */
      pl(s2);                                              /* mod - change */
      nl();
      dn=0;
      while ((dn<64) && (udir[dn].subnum!=-1)) {           /* mod - change */
        switch (try_to_download(s,udir[dn].subnum,1)) {    /* mod - change */
          case -1: dn=100;                                 /* mod - change */
                   abort=1;                                /* mod - change */
                   break;                                  /* mod - change */
          case 0:                                          /* mod - change */
          case 1:  dn++;                                   /* mod - change */
                   break;                                  /* mod - change */
      }
    }
  }                                                        /* mod - add */
}

OK, now for part two.  Load up VARDEC.H and add the following definition:

- #define sysstatus_nscan_file_system 0x0080
- #define sysstatus_funky_colors 0x0100
+ #define sysstatus_nscan_dir 0x4000                      /* mod - add */

NOTE:  LOOK CAREFULLY at the definitions and make sure you don't have something
       else defined as 0x4000.  If you do, change this one to 0x2000, or
       0x1000, or 0x0800, or whatever the next available bit position is.  If
       you don't know what I mean by bit position, ask someone before messing
       this up.

Next, load up VARS.H and add the following variable declaration at the bottom
of the file:

- resultrec *result_codes;
- int num_result_codes;
+ int nscanact;                                         /* mod - add */

Load up FCNS.H and add the following definition at the bottom of the file:

- void quicksort(int l,int r,int type);
- void sortdir(int dn, int type);
- void sort_all(int type);
+ void check_batch_download();                               /* mod - add */

Then load up BBSUTL.C and add the external variable declaration:

- extern unsigned int modem_speed,com_speed;
- extern char ctypes[NUM_CTYPES][18];
+ extern int nscanact;                                       /* mod - add */

Go down to void logon, and add the following line near the end to initialize
the variable when a user logs on:

-   nscandate=thisuser.daten;
+   nscanact=0;                                              /* mod - add */
-   batchtime=0.0;
-   numbatch=0;

Now, load up COM.C and add the following external variable declaration at the
top of the file:

- extern char far *scrn;
- extern messagerec helps[30];
+ extern int nscanact;                                       /* mod - add */

Next, find void outchr(char c), and add the following lines:

    if (c == 10) {
      ++lines_listed;
      if (!(sysstatus_nscan_dir & thisuser.sysstatus) &&     /* mod - add */
          nscanact && (lines_listed >= screenlinest - 2)) {  /* mod - add */
          check_batch_download();                            /* mod - add */
        lines_listed = 0;                                    /* mod - add */
      }                                                      /* mod - add */
      if ((sysstatus_pause_on_page & thisuser.sysstatus) &&
          (lines_listed >= screenlinest - 1)) {
        pausescr();
        lines_listed = 0;
      }
    }

Load up XFER.C, and add the same external variable declarations at the top of
the file as was done for the others:

- extern double extratimecall;
- extern unsigned char realsl;
+ extern int nscanact,lines_listed,screenlinest,curatr;     /* mod - add */

Now find void xfer_defaults(), then add the following code. You may have to
change the option number if you've added anything else in this area - which
most people probably have.

-       thisuser.num_extended,thisuser.num_extended==1?"":"s");
-     pl(s);
+     sprintf(s,"5. Enable download while scanning (%s).",     /* mod - add */
+       thisuser.sysstatus & sysstatus_nscan_dir?"No":"Yes");  /* mod - add */
+     pl(s);                                                   /* mod - add */
-     pl("Q. Quit.");
-     nl();
-     prt(2,"Which? ");
-     helpl=32;
+     ch=onek("Q12345");                                    /* mod - change */
-     switch(ch) {

And right near the bottom of the void:

-         if (s[0]) {
-           i=atoi(s);
-           if ((i>=0) && (i<=10))
-             thisuser.num_extended=i;
-         }
-         break;
+       case '5':                                            /* mod - add */
+         nl();                                              /* mod - add */
+         pl("Do you want to be prompted for files to");     /* mod - add */
+         outstr("download while scanning for new files? "); /* mod - add */
+         if (thisuser.sysstatus & sysstatus_nscan_dir)      /* mod - add */
+           thisuser.sysstatus -= sysstatus_nscan_dir;       /* mod - add */
+         if (!yn())                                         /* mod - add */
+           thisuser.sysstatus += sysstatus_nscan_dir;       /* mod - add */
+         break;                                             /* mod - add */
-     }
-   } while ((!done) && (!hangup));

Then, find void nscandir(int d, int *abort,int title), and add the following
lines:

+   nscanact=1;                                              /* mod - add */
+   if (lines_listed>screenlinest-1)                         /* mod - add */
+     lines_listed=0;                                        /* mod - add */
-   od=curdir;
-   curdir=d;
-   dt=title;

and right near the bottom of the void:

-     read(dlf,(void *)&u,sizeof(uploadsrec));
+     if (nscanact) {                                        /* mod - add */
-       if (u.daten>=nscandate) {
-         if (dt) {
-           printtitle(abort);
-           dt=0;
-         }
-         printinfo(&u,abort);
-       }
+     } else                                                 /* mod - add */
+       abort=1;                                             /* mod - add */
-   }
-   closedl();
-   curdir=od;
+   nscanact=0;                                              /* mod - add */

Then, right after void download add the following code:

+ void check_batch_download()                    /* mod - add entire void */
+ {
+   char ch;
+   int i,i1,done;
+
+   i = curatr;
+   do {
+     done=1;
+     prt(2,"File Scan: C,D,A,?: ");
+     while (!strchr("CDA?\x0d",ch=upcase(getkey())) && !hangup)
+       ;
+     if (hangup)
+       ch='C';
+     switch(ch) {
+       case 'A':
+         nscanact=0;
+       case 13:
+       case 'C':
+         if (okansi()) {
+           setc(i);
+           outstr("\x1b[20D                    \x1b[20D");
+         } else
+           for (i = 0; i < 20; i++)
+             backspace();
+         break;
+       case 'D':
+         pl("D");
+         i1=curdir;
+         closedl();
+         download();
+         curdir=i1;
+         dliscan();
+         setc(i);
+         break;
+       case '?':
+         pl("?");
+         printmenu(16);
+         done=0;
+         break;
+     }
+   } while ((!done) && (!hangup));
+ }

That should do it.  Recompile the whole board because of the changes to FCNS.H
and VARDEC.H.  The way the mod is written, the option will normally be enabled.
If the user wants to turn it off he must do so in the defaults sections.

One last thing - you'll need to update the MENUS.MSG file.  Add the following
to the bottom of the file (you may have to change the menu number in the file
and in the printmenu statement above):

`16===========================================================================
1C3>5ontinue Scan0
1D3>5ownload File(s)0
1A3>5bort Scan0

NOTE: This mod is currently set only to prompt for files to download during
the Newscan operation.  However, it could easily be modified to perform the
same thing for listing or searching by adding the same code that was added to
void nscandir.
