                                  Elric 37
                           Variable Gold per Chain


  Hello, and welcome once again to another mod in the Elrics series. Todays
mod allows you to set up variable gold per chain, so you can let users play
global war for free, and charge them 9 to play Tetris.

Instead of spending all day on a big useless description of everything
it does, and why, I'll just start off with the mod.

=============================================================================

/** this step is indeed a form step, much like a form letter **/
1. From DOS, in your dir where you keep your source....

PKZIP SOURCE *.c *.h

If you already have a source zip file, then

PKZIP -f source *.c *.h

This way you have a copy of everything before you screw it up with a bad mod.
If you decide to take the mod out, it's as easy as
PKUNZIP -x source

and hit Y to overwrite any files you changed.

/** we now resume our regularly scheduled mod with step 2.... **/

=============================================================================

2. Load up Vardec.H. Dont you just love making changes there? Means recompile
the whole BBS, including RETURN.EXE (just to be safe).

Start off by looking for the chainfilerec, and make these changes.

/* DATA FOR OTHER PROGRAMS AVAILABLE */
typedef struct {
	char		filename[81],		/* filename for .chn file */
			description[81];	/* description of it */
	unsigned char	sl,			/* seclev restriction */
			ansir,			/* if ANSI required */
                        gold;                   /* gold cost per game */
	unsigned short	ar;			/* AR restriction */
} chainfilerec;


Just add the line that says gold, making sure to change the semi-colon; after
ansir to a comma.

=============================================================================
3. Still in vardec.h, search down for the exemptions, and add exempt_gold


/* userrec.exempt */
#define exempt_ratio 0x01
#define exempt_time 0x02
#define exempt_all 0x04
#define exempt_post 0x08
#define exempt_gold 0x10      /** add me **/

=============================================================================
4. Now, save that, and load up BBSUTL1.C. Search down for show_chains,
and replace it with this one...

void show_chains(int *mapp, int *map)
{
  int abort,i,i1;
  char s[81];

  abort=0;
  nl();
  pl("#  (Gold) Name");
  for (i=0; (i<*mapp) && (!abort) && (!hangup); i++) {
    sprintf(s,"%2u. (%2u)    %s",i+1,
              chains[map[i]].gold,chains[map[i]].description);
    pla(s,&abort);
  }
  nl();
}

=============================================================================

5. Right under that, you should find run_chains. Make the indicated
additions at the beginning of that procedure.

void run_chain(int cn)
{
  char s[81],s1[81],s2[81];
  int oc;

/** start adding here **/

  if ((chains[cn].gold>0) && !(thisuser.exempt & exempt_gold)){
    if (thisuser.gold<=chains[cn].gold) {
      sprintf(s,"You only have %d gold pieces.\n\rYou need %d to play %s",
               (int) thisuser.gold, chains[cn].gold,chains[cn].description);
      pl(s);
      return;
    }
    sprintf(s,"%s takes away %u pieces of gold for that playing that game",
               syscfg.sysopname,chains[cn].gold);
    pl(s);
    thisuser.gold-=(float) chains[cn].gold;
    sprintf(s,"That leaves you with %d gold pieces.",(int) thisuser.gold);
    pl(s);
    }

/** end of addition **/

  strcpy(s1,chains[cn].filename);
  strcpy(s2,create_chain_file("CHAIN.TXT"));
  stuff_in(s,s1,s2,"","","","");
  sprintf(s2,"!Ran '%s'",chains[cn].description);
  sysoplog(s2);
  oc=chatcall;

=============================================================================

6. Now save BBSUTL1.C, and load up SYSOPF.C. Scan down to modify_chains, and
make the indicated additons and/or changes... Alternately, just block-read
in this segment.


void modify_chain(int n)
{
  chainfilerec c;
  char s[81],s1[81],ch,ch2;
  int i,i1,done;

  c=chains[n];
  done=0;
  do {
    outchr(12);
    print("A. Description  : ",c.description,"");
    print("B. Filename     : ",c.filename,"");
    itoa(c.sl,s,10);
    print("C. SL           : ",s,"");
    strcpy(s,"None.");
    if (c.ar!=0) {
      for (i=0; i<16; i++)
        if ((1 << i) & c.ar)
          s[0]='A'+i;
      s[1]=0;
    }
    print("D. AR           : ",s,"");
    sprintf(s,"E. ANSI         : %s",
      ((c.ansir & ansir_ansi) ? "Required" : "Optional"));
    pl(s);

    sprintf(s,"F. DOS Interrupt: %s",
      ((c.ansir & ansir_no_DOS) ? "Not used" : "Used"));
    pl(s);

    sprintf(s,"G. Gold         : %u",c.gold);  /** add **/
    pl(s);                                     /** add **/


/** This one was letter G, make it H **/
    sprintf(s,"H. 300 Baud     : %s",
      ((c.ansir & ansir_no_300) ?  "Not allowed" : "Allowed"));
    pl(s);

/** same here, change from H to I **/
    sprintf(s,"I. Shrink Out   : %s",
      ((c.ansir & ansir_shrink) ?  "Yes" : "No"));
    pl(s);
    nl();
    prt(2,"Which (A-I,Q) ? ");   /** change prompt **/
    ch=onek("QABCDEFGHI");       /** add I on the end **/
    switch(ch) {
      case 'Q':done=1; break;
      case 'A':
        nl();
        prt(2,"New Description? ");
        inputl(s,40);
        if (s[0])
          strcpy(c.description,s);
        break;
      case 'B':
        nl();
        prt(2,"New Filename? ");
        input(s,40);
        if (s[0]!=0)
          strcpy(c.filename,s);
        break;
      case 'C':
        nl();
        prt(2,"New SL? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<256) && (s[0]))
          c.sl=i;
        break;
      case 'D':
        nl();
        prt(2,"New AR (<SPC>=None) ? ");
        ch2=onek("ABCDEFGHIJKLMNOP ");
        if (ch2==32)
          c.ar=0;
        else
          c.ar=1 << (ch2-'A');
        break;
      case 'E':
        nl();
        prt(5,"Require ANSI? ");
        if (yn())
	  c.ansir |= ansir_ansi;
	else
	  c.ansir &= ~ansir_ansi;
        break;
      case 'F':
        nl();
        prt(5,"Have BBS intercept DOS calls? ");
        if (ny())
	  c.ansir &= ~ansir_no_DOS;
	else
	  c.ansir |= ansir_no_DOS;
        break;
/** add this case in **/
      case 'G':
        nl();
        prt(2,"New Gold Cost? ");
        input(s,3);
        i=atoi(s);
        if ((i>=0) && (i<10) && (s[0]))
          c.gold=i;
        break;
/** end of addition **/

/** change to case H **/
      case 'H':
        nl();
        prt(5,"Allow 300 baud users to run? ");
        if (ny())
	  c.ansir &= ~ansir_no_300;
	else
	  c.ansir |= ansir_no_300;
        break;

/** change to case I **/
      case 'I':
        nl();
        prt(5,"Shrink the BBS to run? ");
        if (yn())
          c.ansir |= ansir_shrink;
        else
          c.ansir &= ~ansir_shrink;
        break;
    }
  } while ((!done) && (!hangup));
  chains[n]=c;
}

=============================================================================

7. Now look down for insert_chain, and add one line.


void insert_chain(int n)
{
  chainfilerec c;
  int i,i1,nu;

  for (i=numchain-1; i>=n; i--)
    chains[i+1]=chains[i];
  strcpy(c.description,"** NEW CHAIN **");
  strcpy(c.filename,"REM");
  c.sl=10;
  c.ar=0;
  c.ansir=0;
  c.gold=0;          /** add me **/
  chains[n]=c;
  ++numchain;
  modify_chain(n);
}

=============================================================================

8. Save the file, and compile the BBS. Load in CHAINCON.C, and compile
in the Large memory model.

=============================================================================

9. Run CHAINCON. When you are finished you can delete it, since you will
   never need it again.

=============================================================================

10. Run the BBS. Should be complete.

=============================================================================
Anyone you choose to exempt from gold should be have 0x10, or 16 in decimal 
if you prefer, added to their exemptions. Since the only other one that does
anything is 0x01, or exempt from D/L ratios, you can give them 17 to be exempt
from both, 16 just for gold, 1 just for D/L, and 0 to enforce everything.



/** hey, it's the form info file **/
As usual, I take no responsibility for hard drive crashes, death in the
family, or end of the world as we know it resulting from this mod.

It's your fault if you didn't back up the files before you made the mod.

It's your fault if you don't back up your ENTIRE hard drive AT LEAST once
a month.

It works on my system with Turbo C 2.0, WWIV 4.1, V20/8088, 640K/640EMS.

If you use this, the only payment I ask is that you send me a note through
WWIVLink to 1@18251 saying you are using it...not too much to ask is it?

The Kingdom of Melnibone(LINK/NET)
812-877-3488  24 Hrs a day
3/12/2400/4800/9600/12,000/14,400 baud HST MNP5
Auto-validation of WWIV sysops on first call
Xmodem, Ymodem, DSZ Zmodem with retry, Ymodem-G

WWIV Link  1@18251

WWIV Net   1@8251
