                                GREENY02.MOD

                         Greeny's online monstrosity.


This mod evolved out of a mutant crossbreeding between somebody's onliner
timelock mod, and the mod that puts a purple box around transfers.  Now it's
a boxed, color-coded timelock mod with bar graphs of comparative usage for
each onliner.  Tacky, eh?  What else are onliners for?

You set a timelock for each onliner.  I.E. this onliner can only be played
from 11:00 pm to 3:00 am.  This is done in //chainedit, and yes I know
entering it in minutes from midnight is annoying.  Sheer lazines on my part.
I made this entire mod under protest and only decided to release it because
it had been so much work.  Anyway, all onliners that are currently
accessible will show up as green to everyone with ansi.  If it's timelocked,
it'll be dark red.  If someone tries to play a timelocked onliner, a message
will appear informing them from when to when the onliner is accessible.  If
they select a green one, it'll just load it up and go.  If you leave the on
and off times at midnight (the default), that onliner will always be green.
If start time is after end time, the available time will continue through
midnight and into the next day.

For those users who don't have ansi, the box will be made out of stuff like
plusses and minuses.  Plus, they can tell timelocked onliners by the
asterisk that appears in the appropriate row all the way to the right.

The bar graphs should be self explanatory.  To zero out the count, remove
and re-install the onliner.  Why you'd want to is beyond me, but it can be
done.

A program called subcnvt is included to convert your chains.dat file to the
new format.  Yes, it is yet another use for black dragon's convert
program.  Somebody give him a medal or something.  To use the
program, block read it out, compile it, go to your data directory,
rename chains.dat chains.old, and subcnvt chains.old chains.dat.  Then if
you're feeling industrious, delete chains.old.

Oh, by the way: exemption 16 exempts people from the timelock.  If you're
already using this for something else, change the #define...


The actual mod comes next.  If you don't back up your source code, you're
dumb.


In the function void modify_chain(int n), which is found in the file
CHNEDIT.C, add/edit the following lines:

/* Key: == already there, ++ add, += change */


==  npr("I. Disable pause: %s\r\n",
==     (c.ansir & ansir_no_pause)?"Yes":"No");
++  npr("J. Switch on at : %d:%02d\r\n",c.lowtime/60,
++              c.lowtime-((c.lowtime/60)*60));
++  npr("K. Switch off at: %d:%02d\r\n",c.hightime/60,
++              c.hightime-((c.hightime/60)*60));
==  nl();
+=  prt(2,"Which (A-K,Q) ? ");
+=  ch=onek("QABCDEFGHIJK");


Farther down in the same function, add the following lines.  (I'd suggest
you block read them in and delete the plusses, but it's up to you.)

==        c.ansir &= ~ansir_no_pause;
==      break;
++    case 'J':
++      nl();
++      prt(5,"Chain Low Time (Mins from midnight)? ");
++      input(s,4);
++      i=atoi(s);
++      if(i>=0 && i<24*60) c.lowtime=i;
++      break;
++    case 'K':
++      nl();
++      prt(5,"Chain High Time (Mins from midnight)? ");
++      input(s,4);
++      i=atoi(s);
++      if(i>=0 && i<24*60) c.hightime=i;
++      break;
==  }
==} while ((!done) && (!hangup));

The next function to modify in is void insert_chain(int n).  Add the
following three lines...

==  c.ansir=0;
++  c.lowtime=0;
++  c.hightime=0;
++  c.usage=0;
==  chains[n]=c;

Now save it off and load up the file BBSUTL1.C.  Delete the entire functions
show_chains and run_chains and replace them with the following:



/* Begin block read for GREENY02.MOD */

void show_chains(int *mapp, int *map)
{
  int abort,next,i,i1,j,k,macks=0,padington;
  char s[81],tempomatic[10];

  abort=0;
  for(i=0;i<*mapp;i++)
    if(chains[map[i]].usage>macks) macks=chains[map[i]].usage;
  nl();
  osan("\0031    Title",&abort,&next);
  for(i=0;i<37;i++) osan(" ",&abort,&next);
  pla(" Popularity    Times run",&abort);
  osan(okansi() ? "\0033" : "+--+",&abort,&next);
  for(i=0;i<42;i++) osan(okansi() ? "" : "-",&abort,&next);
  osan(okansi() ? "" : "+",&abort,&next);
  for(i=0;i<10;i++) osan(okansi() ? "" : "-",&abort,&next);
  pla(okansi() ? "Ŀ" : "+-+" ,&abort);
  for (i=0; (i<*mapp) && (!abort) && (!hangup); i++) {
    strcpy(s,okansi() ? "\0033\0032" : "|");
    if(i<9) strcat(s," ");
    itoa(i+1,tempomatic,10);
    strcat(s,tempomatic);
    osan(s,&abort,&next);
    osan(okansi() ? "\0033 " : "| ",&abort,&next);
    k=1;

  if((chains[map[i]].lowtime!=chains[map[i]].hightime) &&
        !(thisuser.exempt & exempt_timelock))
    if(chains[map[i]].hightime>chains[map[i]].lowtime) {
      if((timer()<=(chains[map[i]].lowtime*60.0)) ||
        (timer()>=(chains[map[i]].hightime*60.0))) k=0;
    } else {
      k=0;
      if((timer()>(chains[map[i]].lowtime*60.0)) ||
        (timer()<(chains[map[i]].hightime*60))) k=1;
    }
    if(!abort && okansi()) {
      if(k) setc(10);
      else setc(4);
    }
    osan(chains[map[i]].description,&abort,&next);
    for(padington=0,j=0;j<strlen(chains[map[i]].description); j++)
      if(chains[map[i]].description[j]==3) padington+=2;
    for(j=strlen(chains[map[i]].description); j<=40+padington;j++)
      osan(" ",&abort,&next);
    osan(okansi() ? "\0033\0037" : "|",&abort,&next);
    j=0;
    if(chains[map[i]].usage)
      if((macks/chains[map[i]].usage)*10)
        for(j=1;j<=((float) chains[map[i]].usage/macks)*10; j++)
          osan(okansi() ? "" : "#",&abort,&next);
    if(j==0) j++;
    while(++j<=11) osan(okansi() ? " " : ":",&abort,&next);
    osan(okansi() ? "\0033" : "|",&abort,&next);
    if(okansi()) setc(4);
    osan(k ? " " : "*",&abort,&next);
    osan(okansi() ? "\0033 \0031" : "| ",&abort,&next);
    sprintf(s,"%05d",chains[map[i]].usage);
    pla(s,&abort);
  }
  osan(okansi() ? "\0033" : "+--+",&abort,&next);
  for(i=0;i<42;i++) osan(okansi() ? "" : "-",&abort,&next);
  osan(okansi() ? "" : "+",&abort,&next);
  for(i=0;i<10;i++) osan(okansi() ? "" : "-",&abort,&next);
  pla(okansi() ? "" : "+-+",&abort);
  nl();
}


void run_chain(int cn)
{
  char s[255],s1[81],s2[81],s3[81];
  int oc,f,blat;
  unsigned int toph,topm,topf,both,botm,botf;
  long l;

  blat=0;
  if((chains[cn].lowtime!=chains[cn].hightime) &&
    !(thisuser.exempt & exempt_timelock))
    if(chains[cn].hightime>chains[cn].lowtime) {
      if((timer()<=(chains[cn].lowtime*60.0)) ||
             (timer()>=(chains[cn].hightime*60.0))) blat=1;
    } else {
    blat=1;
    if((timer()>(chains[cn].lowtime*60.0)) ||
      (timer()<(chains[cn].hightime*60.00))) blat=0;
  }
  if(blat) {
    topf=botf=0;
    toph=chains[cn].hightime/60;
    topm=chains[cn].hightime-(60*toph);
    if(!toph) toph=12;
    if(chains[cn].hightime>=720) {
      toph-=12;
      topf=1;
    }
    both=chains[cn].lowtime/60;
    botm=chains[cn].lowtime-(60*both);
    if(!both) both=12;
    if(chains[cn].lowtime>=720) {
      both-=12;
      botf=1;
    }
    ansic(1);
    npr("\0031%s is only available from %d:%02d%cm to %d:%02d%cm\r\n",
    chains[cn].description,both,botm,botf?'p':'a',toph,topm,topf?'p':'a');
    sprintf(s2,"!Timelock on '%s'",chains[cn].description);
    sysoplog(s2);
    return;
  }
  chains[cn].usage++;
  sprintf(s,"%sCHAINS.DAT",syscfg.datadir);
  f=open(s,O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
  write(f,(void *)chains, numchain * sizeof(chainfilerec));
  close(f);
  itoa(com_speed, s1, 10);
  itoa(syscfg.primaryport,s2,10);
  itoa(modem_speed, s3, 10);
  stuff_in(s,chains[cn].filename,create_chain_file("CHAIN.TXT"),s1,s2,s3,"");
  sprintf(s2,"!Ran '%s'",chains[cn].description);
  sysoplog(s2);
  oc=chatcall;
  chatcall=0;
  l=thisuser.sysstatus;
  if (chains[cn].ansir & ansir_no_pause)
    thisuser.sysstatus &= ~sysstatus_pause_on_page;
  if (chains[cn].ansir & ansir_no_DOS) {
    set_protect(0);
    if (chains[cn].ansir & ansir_shrink)
      shrink_out(s,1,0,1,1);
    else
      run_external(s);
    topscreen();
  } else
    if (chains[cn].ansir & ansir_shrink)
      shrink_out(s,1,1,1,1);
    else
      full_external(s,0,1);
  thisuser.sysstatus = l;
  chatcall=oc;
}

/* End block read for GREENY02.mod */



Save it off.  Load up VARS.H (I know, I know...) and change/add this...

== /* DATA FOR OTHER PROGRAMS AVAILABLE */
== typedef struct {
==      char            filename[81],           /* filename for .chn file */
==                      description[81];        /* description of it */
==      unsigned char   sl,                     /* seclev restriction */
==                      ansir;                  /* if ANSI required */
+=      unsigned short  ar,                     /* AR restriction */
++                      lowtime,
++                      hightime,
++                      usage;
== } chainfilerec;

Farther down, find...

== #define exempt_post 0x08
++ #define exempt_timelock 0x10

Save it.  Compile it.  Get some tea.  Then block read out and compile the
subcnvt program which follows.  You need to use it on your chains.dat file
in the data directory.  Usage subcnvt oldfile newfile.



/* Begin subcnvt.c for greeny's online monstrosity */

/*  CONVERT USERLIST PROGRAM */
/*  Written by The Black Dragon, 1989 */
/*  Mangled by Greeny to do something totally different. */

#include <stdio.h>
#include <string.h>
#include <mem.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
struct {char f[81],d[81],s,an;
        unsigned ar,l,h,u;} new;
struct {char f[81],d[81],s,an;
        unsigned ar;} old;
void main(int argc, char *argv[])
{
  int f,g,i;
  unsigned int loop,num=0;
  unsigned long len;

  if (argc<3) {
    printf("\nRequires 2 parameters.\n");
    printf("Usage: SUBCNVT oldfile newfile \n");
    exit(0);
  }
  if ((f=open(argv[1],O_RDWR|O_BINARY,S_IREAD|S_IWRITE))<=0) {
    printf("\nCould not open chain list %s\n",argv[1]);
    abort();
  }
  if ((g=open(argv[2],O_RDWR|O_BINARY|O_CREAT|O_TRUNC,S_IREAD|S_IWRITE))<=0) {
    printf("\nCould not open output file %s\n",argv[2]);
    abort();
  }
  printf("\n\nSize of old record %d",sizeof(old));
  printf("\nSize of new record %d\n\n",sizeof(new));

  len=filelength(f);
  num=(len/sizeof(old))+!(len%sizeof(old));
  for (loop=0;loop<num;loop++) {
    if (sizeof(old)==read(f,&old,sizeof(old))) {
    printf("\015Processing user #%u of %u",loop,num-1);

    memset(&new,0,sizeof(new));     /* Nice to clear out garbage */
    strcpy(new.f,old.f);          /* Now copy all data over    */
    strcpy(new.d,old.d);
    new.s=old.s;
    new.an=old.an;
    new.ar=old.ar;
    new.l=new.h=new.u=0;
    write(g,&new,sizeof(new));      /* record converted here */
    }
  }
  close(f);
  close(g);
}

/* End subcnvt.c for greeny's online monstrosity */



Try it.  The bar graphs should establish themselves in a few days, and will
be continuously updated each time someone runs an onliner.  The most popular
one will go all the way accross, the rest will be in proportion to it.
(Onliners a user does not have access to will not affect the bar graph
generated for that user.)

Mail about this can be sent to 8@6910.  I don't run a board myself, just
mangle code for people who do.

(GREENY)
THE PROMISED LAND Delran NJ 609-764-7144  Reg. #91223
HOST OF SUB 42 - DEEP THOUGHT: THE INTERNATIONAL MENSA NET
USR 38400/HST/HST/V.32/V.32-BIS/LAPM/V.42/V.42-BIS/MNP/ARQ/ASL
