Lock out lower speed callers.

Recently there was a guy on the net complaining that he could not lock out
lower baud rates.  Several people told him to omit the response codes.  This
does not work quite well.  It is still possible for a caller to connect and
get into the BBS even without the response code.  Here's a quick mod to
bbsutl.c that fixes the annoyance of lower-speed callers.

Search for the junk in the first three lines.  That is WWIV 4.07 code.  Then
insert the stuff between the /*CHANGE*/ and /*ENDCHANGE*/.

------------------------------------------------------------------------------
  checkit=1;
  okmacro=0;
  if ((!net_only) && (incom)) {
/*CHANGE*/
    if ((strcmp(curspeed,"300")==0) || (strcmp(curspeed,"1200")==0)) {
      pl("2400 baud modems cost about $100 now.  If you are too cheap for 
that,");
      pl("then you are too cheap for this place.");
      hangup=1;
      delay(5000);
      dtr(0); }
/*ENDCHANGE*/
------------------------------------------------------------------------------

The "delay" is optional.  My modem is a USR Dual Standard and is buffered.
Without the delay installed, the modem would hangup midway through the
message.  It is a perfect delay for a 300 baud caller and a 1200 baud caller
will


