The Black Dragon #1 @2380
Sat Mar 10 20:03:16 1990
The following modification allows a sysop to rearrange his subs without
disturbing the user's pointers into the subs.  Note that the modification
as given expects 64 subs.  For 32 subs, there is some editing and deleting
to do, but no additions.
===============================( SYSOPF.C )=============================
void insert_sub(int n,int p)
{
  subboardrec r;
  int i,i1,nu;
  userrec u;
  long l1,l2,l3,l4;

  if (p<0) {
    strcpy(r.name,"** NEW SUB **");
    strcpy(r.filename,"NONAME");
    r.readsl=syscfg.newusersl;
    r.postsl=r.readsl+10;
    r.maxmsgs=50;
    r.storage_type=2;
    r.key=r.anony=r.age=r.ar=r.type=0;
  } else r=subboards[p];
  for (i=num_subs-1; i>=n; i--)
    subboards[i+1]=subboards[i];
  subboards[n]=r;
  ++num_subs;
  read_user(1,&u);
  nu=(int) (filelength(userfile) / sizeof(userrec));
  l1=0xffffffff >>(32-(n%32));
  l2=0xffffffff <<((n%32)+1);
  l3=1L << (n%32);
  for (i=1; i<nu; i++) {
    read_user(i,&u);
    l4=((p<0) || ( ((p<32)?u.qscn1:u.qscn2) & (1L << (p%32)) )) ?l3:0;
    if (u.sysopsub!=255)
      if (u.sysopsub>=n)
        ++u.sysopsub;
    for (i1=num_subs-1; i1>n; i1--)
      u.qscnptr[i1]=u.qscnptr[i1-1];
    u.qscnptr[n]=(p>=0) ? u.qscnptr[p] : 0L;
    if (n<32) {
      u.qscn2=(u.qscn2 << 1) | (u.qscn1 >> 31);
      u.qscn1=(u.qscn1 & l1) | ((u.qscn1 << 1) & l2) | l4;
    } else u.qscn2=(u.qscn2 & l1) | ((u.qscn2 << 1) & l2) | l4;
    write_user(i,&u);
  }
}

void boardedit()
{
  int i,done,f;
  char s[81],s1[81],ch;

  if (!checkpw()) return;
  done=0;
  do {
    showsubs();
    nl();
    prt(2,"Subs: D:elete, I:nsert, M:odify, Q:uit, V:Move, ? : ");
    ch=onek("QDIMV?");
    switch(ch) {
      case 'Q': done=1;
      case '?': break;
      case 'D':
        nl();
        prt(2,"Delete which sub? ");
        input(s,2);
        i=atoi(s);
        if (s[0] && (i>=0) && (i<num_subs)) {
          sprintf(s1,"Delete %s? ",subboards[i].name);
          prt(5,s1);
          if (yn()) delete_sub(i);
        }
        break;
      case 'I':
        if (num_subs<64) {
          nl();
          prt(2,"Insert before which sub? ");
          input(s,2);
          i=atoi(s);
          if (s[0] && (i>=0) && (i<=num_subs)) {
            insert_sub(i,-1);
            modify_sub(i);
	  }
        }
        break;
      case 'M':
        nl();
        prt(2,"Sub number? ");
        input(s,2);
        i=atoi(s);
        if (s[0] && (i>=0) && (i<num_subs))
          modify_sub(i);
        break;
      case 'V':
        nl();
        prt(2,"Move which sub? ");
        input(s,2);
        i=atoi(s);
        if (s[0] && (i>=0) && (i<num_subs)) {
          prt(2,"Place before which sub? ");
          input(s,2);
          f=atoi(s);
          if (s[0] && (f>=0) && (f<=num_subs) && (f!=i)) {
            nl();
            sprintf(s1,"Move %s to %u? ",subboards[i].name,f);
            prt(5,s1);
            if (yn()) {
              insert_sub(f,i);
              delete_sub((f>i) ? i : (i+1) );
            }
          }
        }
        break;
    }
  } while (!done && !CHECK_BIT(port_status,HANGUP));
  sprintf(s,"%sSUBS.DAT",syscfg.datadir);
  f=open(s,O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
  write(f,(void *)&subboards[0], num_subs * sizeof(subboardrec));
  close(f);
}
=========================( End of Modification )========================
