Parker Prospect #1 @9964
Sun Apr 29 22:33:09 1990
      +---------------------------------------------------------+
      + Turn Off [PAUSE] Prompting For Selected Chains Mod v2.0 +
      +---------------------------------------------------------+

This idea came to me after a lot of complaining on Filo's part (grin)
about how his Waffle program would not work with a user's [PAUSE]
prompting set on. I turned it over and over in my mind, but I was just
too lazy to actually write the thing. Finally, Filo directly sent me
some mail asking me to spare some time off to write this mod. Since I
knew it wouldn't take but maybe 30 minutes at most, I said sure, and
went to work.

What this mod does is allow the sysop to have the option (set in
//CHAINEDIT) of turning off a user's [PAUSE] prompting option, if the
user has it set on, when the user runs a chain.  This mod involves a lot
of files, but it isn't really that much work. Enjoy!
                                                     - PP April 26, 1990

NOTE: I have deleted the end of some of the lines that were not modified
due to margin requirements.  If you see a line that is different in this
mod listing, but does not have a '++' or a '-+' on the front of it, DO
NOT MODIFY IT!

VERSION 2.0 NOTES: I fixed the bug where a non-shrink chain put a [PAUSE] on
the screen after returning from it.


                 ************************************
                 ************** Legend **************
                 ************************************
                 * %% Delete Line                   *
                 * -- Search for Line, DON'T CHANGE *
                 * ++ Add Line                      *
                 * -+ Modify Line                   *
                 * ## Line is part of another mod   *
                 ************************************


------------------------------------------------------------------------
Step #1 <VARS.H>: Add the following line to the end of the file.

long save_user_defaults;


------------------------------------------------------------------------
Step #2 <VARDEC.H>: Insert the following lines.

++ /* chainfilerec.ansir */
-- #define ansir_ansi 0x0001
-- #define ansir_no_DOS 0x0002
-- #define ansir_no_300 0x0004
-- #define ansir_shrink 0x0008
++ #define ansir_pause_on 0x0010


------------------------------------------------------------------------
Step # <BBSUTL.C>: Edit according to legend at top of file.

-- extern int incom,outcom,msgreadlogon;
-- extern int fsenttoday,userfile,chatcall,mailcheck,smwcheck;
-- extern char chatreason[81],irt[81];
-- extern subboardrec subboards[32];
-+ extern long nscandate, save_user_defaults;
-- extern float batchtime;
-- extern int numbatch,numed,lines_listed;
-- extern editorrec *editors;
-- extern gfiledirrec *gfilesec;


------------------------------------------------------------------------
Step # <BBSUTL.C>: Edit according to legend in void logoff.

--   double ton;

--   dtr(0);
--   hangup=1;
++   save_user_defaults = 0;
--   thisuser.lastrate=modem_speed;
--   strcpy(thisuser.laston,xdate);
--   thisuser.sl=realsl;


------------------------------------------------------------------------
Step # <BBSUTL1.C>: Edit according to legend at top of file.

-- #include <fcntl.h>
-- #include <alloc.h>
-- #include "vardec.h"
-- #include "fcns.h"

++ extern int lines_listed;
++ extern long save_user_defaults;
-- extern int hangup;
-- extern char dc[81],dcd[81],odc[81];
-- extern char charbuffer[161];


------------------------------------------------------------------------
Step # <BBSUTL1.C>: REPLACE void run_chain with the one listed below.

void run_chain(int cn)
{
  char s[81],s1[81],s2[81];
  int oc;

  strcpy(s1,chains[cn].filename);
  strcpy(s2,create_chain_file("CHAIN.TXT"));
  stuff_in(s,s1,s2,"","","","");
  sprintf(s2,"!Ran '%s'",chains[cn].description);
  sysoplog(s2);
  oc=chatcall;
  chatcall=0;
  save_user_defaults = thisuser.sysstatus;
  if (chains[cn].ansir & ansir_pause_on) {
     if (sysstatus_pause_on_page & thisuser.sysstatus) {
       thisuser.sysstatus ^= sysstatus_pause_on_page;
     }
  }
  if (chains[cn].ansir & ansir_no_DOS) {
    set_protect(0);
    if (chains[cn].ansir & ansir_shrink)
      shrink_out(s,1,0,1,1);
    else
      run_external(s);
    topscreen();
  } else
     if (chains[cn].ansir & ansir_shrink)
       shrink_out(s,1,1,1,1);
     else
       full_external(s,0,1);
  chatcall=oc;
  thisuser.sysstatus = save_user_defaults;
  lines_listed = 0;
}


------------------------------------------------------------------------
Step # <SHRINK.C>: Edit according to legend at top of file.

-- #define READ(x) read(f,&(x),sizeof(x))

-- #define WRITE(x) write(f,&(x),sizeof(x))
-- extern int noklevel,oklevel,ooneuser,no_hangup,ok_modem_stuff,
-- extern int sysop_alert,do_event,incom,outcom,defscreenbottom,
-+ extern long last_time_c, save_user_defaults;
-- extern char *xenviron[50];

-- extern unsigned char andwith;

-- extern int usernum,chatcall,cursub,curdir,curdloads,msgreadlogon,


------------------------------------------------------------------------
Step # <SHRINK.C>: Edit according to legend in int restore_data.

--        READ(xtime);
--        READ(xdate);
--        READ(incom);
--        READ(outcom);
--        READ(global_handle);
++        READ(save_user_defaults);

--        if (global_handle) {
--             global_handle=0;
--             set_global_handle(1);
--        }

--        read_user(usernum,&thisuser);
--        useron=1;
--        realsl=actsl=thisuser.sl;
--        changedsl();
--        topscreen();
--        set_baud(com_speed);
++        thisuser.sysstatus = save_user_defaults;
--   }

--   close(f);
--   unlink(s);
--   unlink("stat.wwv");


------------------------------------------------------------------------
Step # <SHRINK.C>: Edit according to legend in void save_state.

--        WRITE(xdate);
--        WRITE(incom);
--        WRITE(outcom);
--        WRITE(global_handle);
++        WRITE(save_user_defaults);

--        set_global_handle(0);
--   }

--   close(f);


------------------------------------------------------------------------
Step # <SYSOPF.C>: Edit according to legend in void modify_chain.

-- #include <fcntl.h>
-- #include <sys\stat.h>
-- #include <time.h>
-- #include <dir.h>

++ extern long save_user_defaults;
-- extern subboardrec subboards[32];
-- extern directoryrec directories[64];
-- extern int num_subs, num_dirs,hangup,userfile,echo,useron,wfc,
-- extern int incom,fwaiting;


------------------------------------------------------------------------
Step # <SYSOPF.C>: Edit according to legend in void modify_chain.

--              case 'H':
--                   nl();
--                   prt(5,"Shrink the BBS to run? ");
--                   if (yn())
--                        c.ansir |= ansir_shrink;
--                   else
--                        c.ansir &= ~ansir_shrink;
--                   break;
++              case 'I':
++                   nl();
++                   prt(5,"Turn user's [PAUSE] prompt off? ");
++                   if (yn())
++                        c.ansir |= ansir_pause_on;
++                   else
*++                        c.ansir &= ~ansir_pause_on;
++                   break;
--         }
--    } while ((!done) && (!hangup));
--    chains[n]=c;
-- }


------------------------------------------------------------------------
Step # <SYSOPF.C>: Edit according to legend in void modify_chain.

--             pl("G. 300 Baud     : Allowed");
--        if (c.ansir & ansir_shrink)
--             pl("H. Shrink       : Yes");
--        else
--             pl("H. Shrink       : No");
++        if (c.ansir & ansir_pause_on)
++             pl("I. Pause Off    : Yes");
++        else
++             pl("I. Pause Off    : No");
--        nl();
-+        prt(2,"Which (A-I,Q) ? ");
-+        ch=onek("QABCDEFGHI");
--        switch(ch) {
--             case 'Q':done=1; break;
--             case 'A':


------------------------------------------------------------------------
Step # <UTILITY.C>: Edit according to legend in void frequent_init.

-- void frequent_init()
-- /* This should be called after a user is logged off, and will
--   * initialize screen-access variables.
--   */
-- {
##    byline[0]=0;
++    save_user_defaults = 0;
--    ansiptr=0;
--    curatr=0x07;
--    outcom=0;


------------------------------------------------------------------------
Step # <UTILITY.C>: Edit according to legend at top of file.

-- #include "vardec.h"
-- #include "fcns.h"
-- #include "net.h"

++ extern long save_user_defaults;
-- extern int outcom,incom,dlf,okskey,input_extern,chat_file,two_color;
-- extern int charbufferpointer,screenlinest,restoring_shrink;
-- extern int hangup,hungup,using_modem;


------------------------------------------------------------------------
Final Step

Compile the BBS and update your menus to reflect the changes you made...


------------------------------------------------------------------------
Disclaimer

I, Jeff Garzik, claim no liability for this mod, or for any damage that
may have resulted from the use of this mod.  I also attach no warranty,
expressed OR implied, to this product.  This type of warranty and
liability disclaimer is prohibited by law in certain states, and is
therefore void in those states.

If you like this mod, you can call my board at:

     The East Carolina Connection
     919-756-2939 :::: 2400 baud MNP level 4
     24hrs a day -- 7 days a week
     Autovalidation of WWIV sysops (first call)

Thanks to Wayne Bell for writing such great software!
