Goose #14 @7303
Sun Apr 01 13:02:58 1990
                            Change Time Display Mod
                               by Goose, 1 @ 7312

This mod is based on an idea I got from the WWIVnet Mods Net (although I don't
remember whp posted the original request).  What it does is change the time
displayed when Ctrl-T is pressed, or in the header of a message, from the
standard ctime call of :

Sun Apr 1 14:28:12 1990

to the following form, which seems a little more "normal" :

Sunday, April 1, 1990   2:28 pm

Basically, it moves the year after the day where it belongs, changes the time
to the am/pm indication rather than the 24 hour clock, and removes the seconds
(I could have left these on but I can't see what anybody needs to know the
exact second a message was posted).

First, edit FCNS.H and add the following call (again, like all my mods, -
indicates existing code and + new or modified code) :

- char *date();
- char *times();
+ char *atime();                                             /* mod - add */
- unsigned int finduser(char *s);
- void changedsl();

Then, in UTILITY.C read in the following code after char *times() :

-   return(ti);
- }
-
+ char *atime()                                    /* mod - add entire char */
+ {
+   static char dt[81];
+   char dow[10],mon[10],ap[10];
+   int i,d,y;
+   union REGS r;
+
+   r.h.ah = 0x2a;
+   r.h.al = 0;
+   int86(0x21, &r, &r);
+   switch (r.h.al) {
+     case 0 : strcpy(dow,"Sunday");    break;
+     case 1 : strcpy(dow,"Monday");    break;
+     case 2 : strcpy(dow,"Tuesday");   break;
+     case 3 : strcpy(dow,"Wednesday"); break;
+     case 4 : strcpy(dow,"Thursday");  break;
+     case 5 : strcpy(dow,"Friday");    break;
+     case 6 : strcpy(dow,"Saturday");  break;
+   }
+   switch (r.h.dh) {
+     case 1  : strcpy(mon,"January");   break;
+     case 2  : strcpy(mon,"February");  break;
+     case 3  : strcpy(mon,"March");     break;
+     case 4  : strcpy(mon,"April");     break;
+     case 5  : strcpy(mon,"May");       break;
+     case 6  : strcpy(mon,"June");      break;
+     case 7  : strcpy(mon,"July");      break;
+     case 8  : strcpy(mon,"August");    break;
+     case 9  : strcpy(mon,"September"); break;
+     case 10 : strcpy(mon,"October");   break;
+     case 11 : strcpy(mon,"November");  break;
+     case 12 : strcpy(mon,"December");  break;
+   }
+   d=r.h.dl;
+   y=r.x.cx;
+   r.h.ah = 0x2c;
+   r.h.al = 0;
+   int86(0x21, &r, &r);
+   i=r.h.ch;
+   if (i>12)
+     i-=12;
+   if (i==0)
+     i=12;
+   if (r.h.ch<12)
+     strcpy(ap,"am");
+   else
+     strcpy(ap,"pm");
+   sprintf(dt,"%s, %s %d, %4d  %2d:%02d %s",dow,mon,d,y,i,r.h.cl,ap);
+   return(dt);
+ }
-
- unsigned int finduser(char *s)

Then, in COM.C make the following change to update the Ctrl-T prompt in
void ptime() :

-   nl();
+   /* mod - delete time(&l);             */
+   /* mod - delete strcpy(s, ctime(&l)); */
+   /* mod - delete s[strlen(s) - 1] = 0; */
+   strcpy(s,atime());                             /* mod - add */
-   pl(s);
-   if (useron) {

And finally, in MSGBASE.C make the following change to update the date and
time in the message header (near the bottom of void inmsg(.....)) :

-     if (real_name)
-       addline(b,thisuser.realname,&l1);
-     else
-       addline(b,nam1(&thisuser,usernum,syscfg.systemnumber),&l1);
+     /* mod - delete time(&ll);            */
+     /* mod - delete strcpy(s,ctime(&ll)); */
+     /* mod - delete s[strlen(s)-1]=0;     */
+     strcpy(s,atime());                           /* mod - add */
-     addline(b,s,&l1);
-     if (irt[0]) {

I think that's all the calls to ctime in the BBS, but if you find others you
can change them in the same way.  All you need to do now is recompile the
*entire* board since FCNS.H changed, and you'll be all set.  If you have any
problems with this mod, I can be reached at 1@7312.

3 2Goose 30
