AKID4.MOD for WWIV 4.20

Programmed by the Analog Kid, 1@5482
               of Permanent Waves BBS
               (514) 844-0214
               Montreal, Quebec,
               Canada

Makes a three-column external door display, with colours.  Will do so
provided that the user has a display width length of at least 80 
characters (otherwise, a single column is printed while maintaining
the colours).

Instructions:  Open your BBSUTL1.C file, search for function "show_chains"
and replace it with the one following (patch and paste your way through).

void show_chains(int *mapp, int *map)     /* AKID4.MOD, by the Analog Kid */
{                                         /* Permanent Waves BBS, 1@5482  */
  int abort,i,posit;                      /* Montreal, Quebec, Canada     */
  char s[102],s1[90];                     /* (514) 844-0214               */

  abort=posit=i=0;
  nl();
  if (thisuser.screenchars<80)
  {
    pl(" External Programs ");
    nl();
    for (i=0; (i<*mapp) && (!abort) && (!hangup); i++)
    {
      sprintf(s1,"[%2d] %s",i+1,chains[map[i]].description);
      pla(s1,&abort);
    }
  }
  else
  {
    pl("                           External Programs ");
    nl();
    while ((i<*mapp) && (!abort) && (!hangup))
    {
      sprintf(s1,"[%2d] %s",i+1,chains[map[i]].description);
      if (strlen(s1)>31)
        s1[31]=0;
      else
        while (strlen(s1)<=30)
          strcat(s1," ");
      if (posit!=0)
      {
        strcat(s,"    ");
        strcat(s,s1);
        if (posit==2)
        {
          pla(s,&abort);
          posit=0;
        }
        else
          posit=2;
      }
      else
      {
        strcpy(s,s1);
        posit=1;
      }
      i++;
    }
    if (posit!=0)
      pla(s,&abort);
  }
  nl();
}

Disclaimer:  It works well on Permanent Waves... I believe it should do
likewise on your board.  I cannot, however, be held in any way responsible
if things go awry in one way or another.  Let me know if you are having 
difficulty and I'll do my very best to assist you - but don't come 
running to me because of mod frustrations that resulted in the death of
your dog named Rex.

Please do me a favour:  All criticism, suggestions and (especially!)
praising are very welcome and kindly asked for.  Please do yourself
a favour:  Insert Roll The Bones into stereo, play loud.  Many Thanks.
