			     Fix ANSI Lockup Mod
                               by Goose, 1@7312

This mod fixes a problem where WWIV may hang when invalid ANSI strings are
displayed.  I decided to figure out what the problem was after my board
crashed after a user was trying to upload an ANSI screen, and seeing other
weird things happen during the display of ANSI characters.

This is a really simple mod, and I'm sure it'll be fixed in the next release
of WWIV (at least I hope so).  Load up COM.C, and find void execute_ansi().
Go down about 20 lines to where he starts to parse the ANSI string, and make
the following one line change:

    cmd = ansistr[ansiptr - 1];
    ansistr[ansiptr - 1] = 0;
    while ((ansistr[ptr]) && (tempptr<10) && (argptr<10)) {  /* mod - change */
      if (ansistr[ptr] == ';') {
        temp[tempptr] = 0;

Basically, the problem was that the code didn't check the length of the ANSI
string, since all *valid* ANSI strings will be less than the ten characters
declared.  However, with a little garbage in there (we all have heard of line
noise) it can overwrite many different variables and cause all sorts of
strange things to happen.  If you have any problems with this mod... well, I'm
sure you won't so I'll leave off the normal closing line.

T.T.F.N.

3 2Goose 30

