/*************************************************************************


			Auto Ansi Sensing Mod.
		     For Wayne Bell's Production:
			      W.W.I.V.
			   Programming by:
			 Lt. Hytiek #1 @3504
			   WWIV REG #90406


**************************************************************************/

	Ok Wayne,  First step... Load up BBSUTL.C and insert these
	two voids into the beginning of the file, right after the
	extern's...

********************
**     Legend     **
**  =  Original   **
**  +  Added      **
**  etc.........  **
********************

+void check_ansi(int *abort)
+{
+  char ch;
+
+  while ((!empty()) && (!(*abort)) && (!hangup)) {
+    checkhangup(); ch=inkey(); lines_listed=0;
+    switch(ch) { case '[':*abort=1;break; }
+  }
+}

+void ansi_checking_print(char *s, int *abort)
+{
+  int i;
+
+  i=0; checkhangup();
+  if (hangup)
+    *abort=1;
+  check_ansi(abort);
+  while ((s[i]) && (!(*abort))) {
+    outchr(s[i++]); delay(10); check_ansi(abort);
+  }
+}

/***************************************************************************
	Ok, now that you have added those two voids, the search for
	"void getuser(blah)"...  Follow the code:


	Add to the 'int' statement of 'void getuser': "i,abort;"
	Now follow the below code work...

****************************************************************************/

=  checkit=1;
=  okmacro=0;
=  if ((!net_only) && (incom)) {
+    abort=0;
+    outstr("\n\rAuto-Sensing ANSI...");
+    nl();
+    thisuser.sysstatus=0;
+    echo=0;
+    abort=0;
+    pr1("\x1b[6n");
+    for (i=0; i<5; i++) {
+      ansi_checking_print(" ",&abort);
+      check_ansi(&abort);
+      if (abort)
+	strcpy(s4,"Y");
+    }
+    echo=1;
+    if (strcmp(s4,"Y")==0) {
+      print("\n\r\x1b[1;32;36mANSI Sensed.","");
+      pausescr(); printfile("welcome.ans");
+    } else {
+      outstr("\n\rASCII Sensed, ANSI Failed.\n\r"); pausescr();
+      printfile("welcome.msg");
+    }
=  }
=  ansic(0);
=
=  do {
=    nl();
=    if (net_only) {
=      pl("This time is reserved for net-mail ONLY.");
=      pl("Please try calling back again later.");
=    } else pl("Enter number or name or 'NEW'");
+    ok=0;
=
=    outstr("NN: "); /* DON'T change the NN: prompt. */


/************************************************************************

	That is all there is to it, the way that this mod works
	is by sending the command string "ESC[6n" to the modem.
	What in turn that does is actually sends it to the remotes
	terminal program (Instead of physically printing it), and
	then the users term program will send back a result code,
	starting with the LEFT bracket. (What you would see if you
	sent the CODE to the screen is: "[5;1R".  Anyways, that should
	do it.  Pretty simple.  Another mod that I suggest is the
	Profanity Restrictor...  I will Email that to you as well.
	If there is anything I could do/help you with, please ask.
	I would be more then happy to help out.  Thank you, and
	enjoy the ANSI.


Lt. Hytiek #1 @3504 WWIV Reg 90406
Data/BBS Number: 305-435-8810 (USR V.32 Modem, 9600/ARQ)
*************************************************************************/
