Heath Smith #5 @3353 [Brighton, Michigan]
Wed Apr 25 11:11:30 1990

ANSI auto detection mod.
------------------------

Modification will allow you to auto-detect ansi on remote terminal. Currently
it is only used to display the appropriate welcome message, but the function
check_ansi can easily be implemented elsewhere. See function getuser for
the typical calling conventions.

BUG FIX! BUG FIX!

Last version had a bug!

With the old version, if the user hung up while ansi was being auto
detected, the system would lock. This may not have happened with all
systems, but it did happen. This version cleans up things a bit.


Ansi Auto Detect Mode for WWIV411.
----------------------------------

Purpose: To auto-detect ANSI at remote terminal and to display the
         appropriate welcome screen to user.

=================================================================

Step 1)
-------

Load BBSUTL.C and search for "void getuser"

Insert this function above the "void getuser" function.


int check_ansi()

{
  char s[12];
  int  slength;

  while (comhit())
    if (get1c()==0);
  nl();
  outstr ("Auto Detecting Ansi (Wait...)");
  nl();
  nl();
  outstr("\x1b[6n");

  wait((double)2);
  checkhangup();
  if (!hangup)
    {
      if (comhit())
        {
          slength=0;
          while ( (comhit()) && (slength<=10) )
            s[slength++]=get1c();
          if (!(comhit()))
            {
              slength--;
              if ( (s[0]=='\x1b') && (s[slength]=='R') )
                return(1);
              else
                return(0);
            }
          else
            dump();
        }
      else
        return(0);
    }
  else
    {
      dump();
      return(0);
    }
}

=================================================================

Step 2)
-------

Search in the "void getuser" function for the existing lines of code,
replace all lines between existing code with the new code.

= existing code
---------------

= count=0;
= ok=0;
= checkit=1;
= okmacro=0;
= if ((!net_only) && (incom))
    {
      if (check_ansi())
        {
          if (!(hangup))
            {
              nl();
              outstr("\x1b[1;32;36mANSI Sensed.");
              nl();
              strcpy(s,syscfg.gfilesdir);
              strcat(s,"welcome.ans");
              if (exist(s))
                printfile ("welcome.ans");
              else
                printfile("welcome.msg");
            }
        }
      else
        {
          if (!(hangup))
            {
              nl();
              outstr("No ANSI detected.");
              nl();
              outstr("Check you com. program for ANSI capability If you want ANSI.");
              nl();
              outstr("ANSI allows for color, full-screen editing, and games!");
              nl();
              printfile("welcome.msg");
            }
        }
    }

= ansic(0);
= do {
=   nl();
=   if (net_only) {
=     pl("This time is reserved for net-mail ONLY.");

=================================================================

Done!

Recompile BBS.

Mod by Heath Smith and
       Tim Rappette
       @3353
       313-231-2366 Ufo Data Collecton Center

Call if you need assistance.


