/*  CONVERT Chains.DAT PROGRAM */

/*  Command Parameters:  */
/*  CHAINCON  */



/** Ok. signifigant changes to the convert software, as in I re-wrote the
whole thing mostly from scratch.
Just compile it, stick it in the main BBS dir, and type CHAINCON, and it
does the rest.

The only thing I will add is that it was compiled and tested under
Turbo C 2.0, and it was tested in the large memory model. Use whatever you
want, I think it should work in all of them.

Lord Elric  1@18251 LINK  1@8251 NET */



#include <stdio.h>
#include <string.h>
#include <mem.h>
#include <io.h>
#include <stdlib.h>
#include <fcntl.h>
#include "vardec.h"
/* DATA FOR OTHER PROGRAMS AVAILABLE */
typedef struct {
	char		filename[81],		/* filename for .chn file */
			description[81];	/* description of it */
	unsigned char	sl,			/* seclev restriction */
			ansir;			/* if ANSI required */
	unsigned short	ar;			/* AR restriction */
} oldchainfilerec;

void main()
{
  FILE *infile,*outfile;
  unsigned int l,num=0;
  oldchainfilerec old[99];
  chainfilerec new[99];
  int configfile;
  configrec syscfg;
  char s[81],s1[81];

  configfile=-1;
  strcpy(s,"CONFIG.DAT");
  configfile=open(s,O_RDWR | O_BINARY);
  if (configfile<0) {
    printf("%s NOT FOUND.\n",s);
    printf("This program must be run from the main BBS directory\n");
    exit(0);
    }
  read(configfile,(void *) (&syscfg), sizeof(configrec));
  close(configfile);

  sprintf(s1,"%sCHAINS.DAT",syscfg.datadir);
  sprintf(s,"%sCHAINS.XXX",syscfg.datadir);
  printf("\nNow renaming %s to %s\n",s1,s);
  if (rename(s1,s) != 0) {
    printf("\nCould not rename...please delete/rename file %s",s);
    exit(0);
    }


  if ((infile=fopen(s,"rb"))==NULL) {
    printf("\nCould not open input chains file %s\n",s);
    abort();
  }
  num=fread(old,sizeof(oldchainfilerec),99,infile);
  fclose(infile);
  printf("\nSize of old chain record : %d",sizeof(oldchainfilerec));
  printf("\nSize of new chain record : %d\n\n",sizeof(chainfilerec));

  memset(&new,0,99*sizeof(chainfilerec));

  for (l=0;l<num;l++) {
    printf("Processing chain #%u of %u, %40s\n",l,num,old[l].description);
    strcpy(new[l].description,old[l].description);
    strcpy(new[l].filename,old[l].filename);
    new[l].sl   =old[l].sl;
    new[l].ansir=old[l].ansir;
    new[l].ar   =old[l].ar;
    new[l].gold=0;
  }
  if ((outfile=fopen(s1,"wb"))==NULL) {
    printf("\nCould not open output chains file %s\n",s1);
    rename(s,s1);
    abort();
  }
  fwrite(new,sizeof(chainfilerec),num,outfile);
  fclose(outfile);
  unlink(s);
}
