Medicine Man #1 @2101
Sat Mar 10 11:02:35 1990
58/200: Check all dirs mod...
Name: Goose #15 @7302
Date: Thu Jan 25 23:04:28 1990
From: NoName's BBS [703-754-0884]

The only thing I can think of with all these problems is that the version of 
the mod you are using is back-level.. I originally wrote the mod to check the 
actual directories for the file name and if was present on the disk, don't 
allow it to be uploaded...  however, this didn't work for offline files.  BUT _
I have been using this mod on my system without any probs for a while, so it 
may have been a backlevel that made it out (damn, I hope not).  Anyway, I'll 
repost it here so those who are having problems can recheck it...


                     Search All Directories before Upload

This mod helps get rid of the problem of the same file being uploaded several
times.  Normally WWIV only checks the current directory before performing an
upload, however, there is nothing to prevent the file from already existing in
another directory.  What this mod does is scans all the directories the user
has access to after the user types in the file name, and if it is found it
warns them and shows them the information for the file that is already there.

Load up XFER.C and find void upload(int dn), and make the following additions
in the code:

-         pl("Can't upload locally.");
-         nl();
-         ok=0;
-       }
+     if ((ok) && (incom) && (!resume))                       /* mod - add */
+       ok=check_exist(dn,s);                                 /* mod - add */
-     if ((d.mask & mask_PD) && (ok)) {
-       nl();
-       prt(5,"Is this program PD/Shareware? ");

Then, either before or after void upload, read in the following code:

int check_exist(int dn,char *fn)                /* mod - add entire void */
{
  uploadsrec u;
  int idn,ocd,ok,abort;

  nl();
  pl("Scanning all directories.");
  ocd=curdir;
  ok=1;
  abort=0;
  for (curdir=1; (curdir<64) && (ok) && (udir[curdir].subnum!=-1); curdir++) {
    closedl();
    dliscan();
    for (idn=1; (idn<=numf) && (!abort) && (!hangup); idn++) {
      SETREC(idn);
      read(dlf,(void *)&u,sizeof(uploadsrec));
      if (compare(fn,u.filename)) {
        nl(); prt(6,"File already exists!"); nl();
        printtitle(&abort);
        printinfo(&u,&abort);
        ok=0;
      }
    }
  }
  curdir=ocd;
  closedl();
  dliscan1(dn);
  return(ok);
}

One final note: if you change the FOR line in the above code to read:

for (curdir=0 ...............

rather than:

for (curdir=1 ...............

the SYSOP directory will be checked also.  I don't like users prying eyes in
my sysop dir, but if you don't mind you may want to change that also...

I hope this fixes the problems for those who had tried to install my previous 
mod... and if you had, sorry for any aggravation I may have caused...

 Goose 
1 @ 7312
