Tony Godfrey #1 @18
Thu Mar 22 08:59:39 1990
                              GoldSys
                              Version 1.5
                              by Tony Godfrey
                              March 22, 1990
                              Turbo C 2.0
                              WWIV v4.11

                              Explanation
                              -----------
     This modification to WWIV v4.11 (*) is an alternative to the
S.A.L.T. II modification by "Slick the Slickster".  S.A.L.T. II
works with WWIV, however, when using WWIVnetted subs, the S.A.L.T.
II system corrupts the SUBS.DAT files, and all WWIVnet messages
will disappear into nothingness.  I thank "Slick the Slickster" for
his brilliant idea, as I have made a new gold system that follows
his, without losing WWIVnet messages.
     Here's how it works:  the SysOp (or his remote SysOps) can
configure the amount of gold given per post on individual message
bases, and can configure the amount of gold taken away per play of
individual online chains.  For example, if the SysOp(s) configure
message base 1 to give 5 gold per post and message base 2 to give
7 gold per post, that is exactly what happens.  If the SysOp(s)
configure online chain 1 to take 3 gold per play and online chain
2 to take 8 gold per play, that is exactly what happens.  The
finished product will look something like this, when the "*" key
is pressed for a sub listing:

1. (5) - General Discussion
2. (7) - Computer Discussion

A chain listing looks like this:

1. (3) Leech
2. (8) King of the Hill Trivia

     Also taken into account is how much gold is taken back if a
user removes his/her post.  If a user removes a post from a message
base that gives 5 gold per post, 5 gold will be taken away.
     The SysOp can edit gold using "//GOLDEDIT" at the main menu or
by pressing "$" at the "Waiting For Caller" screen.

                         Additions to Version 1.2
                         ------------------------
     In version 1.2 of GoldSys, the SysOp does not need to rearrage
gold
when he/she inserts and deletes chains and subs.  When the SysOp
inserts
or deletes chains and subs, gold amounts of zero are also inserted,
keeping the amounts of gold per sub/chain in their correct order.


                              Installation
                              ------------
     Included with this documentation file are five files: 
GOLDSYS1.C," "GOLDSYS2.C," "GOLDSYS3.C," "GOLDSYS4.C" and
"GOLDSYS5.C"  Be sure you have these files, as they are required to
completely install GoldSys.  In order to install GoldSys, you must
complete the following steps:

     1) Load Turbo C
     2) Load the "VARS.H" file
     3) At the end of this file, add the following line:

 int rewardgold[64],costgold[64];

     4) Save the "VARS.H" file
     6) Load the "BBS.C" file
     7) In "void sublist()" do the following:

FIND:     int i,abort;
CHANGE:   char s[80],s1[80];
ADD:      goldload();
FIND:     if (s[1]==0)
EXIST:      s[1]=32;
ADD:      itoa(rewardgold[usub[i].subnum],s1,10);
ADD:      strcat(s," (");
ADD:      strcat(s,s1);
ADD:      strcat(s,")");
EXIST:    strcat(s," - ");
EXIST:    if (syscfg.systemnumber)

     8) In "void mainmenu()" do the following:

FIND:     if ((strcmp(s,"CHAINEDIT")==0) && (so())) {
EXIST:      sysoplog("@ Ran Chainedit");
EXIST:      chainedit();
EXIST:    }
ADD:      if ((strcmp(s,"GOLDEDIT")==0) && (so())) {
ADD:        sysoplog("@ Ran Goldedit");
ADD:        goldedit();
ADD:      }

     9) In "void answer_phone()" do the following:

FIND:     outs("Answering phone, 'H' to abort.\r\n");
ADD:      goldload();
EXIST:    pr1(syscfg.answer);

     10) In "void getcaller()" do the following:

FIND:         gfileedit();
EXIST:        holdphone(0);
EXIST:      }
EXIST:      okskey=0;
EXIST:      break;
ADD:      case '$':
ADD:        okskey=1;
ADD:        if (ok_local()) {
ADD:          holdphone(1);
ADD:          goldedit();
ADD:          holdphone(0);
ADD:        }
ADD:        okskey=0;
ADD:        break;

     11) Save the "BBS.C" file
     12) Load the "BBSUTL.C" file
     13) Do the following:

FIND:     extern char ctypes[NUM_CTYPES][18];
ADD:      extern int rewardgold[64],costgold[64];

     14) At the very end of the "BBSUTL.C" file, read in the     
         "GOLDSYS1.C" file
     15) Save the "BBSUTL.C" file
     16) Load the "BBSUTL1.C" file
     17) Do the following:

FIND:     extern chainfilerec *chains;
ADD:      extern int rewardgold[64],costgold[64];

     18) In "void show_chains(int *mapp, int *map)" do the     
         following:

FIND:     int abort,i,i1;
CHANGE:   char s[81],s1[81];
ADD:      goldload();
EXIST:    abort=0;
EXIST:    nl();
EXIST:    for (i=0; (i<*mapp) && (!abort) && (!hangup); i++) {
EXIST:      itoa(i+1,s,10);
CHANGE:     strcat(s,". (");
ADD:        itoa(costgold[i],s1,10);
ADD:        strcat(s,s1);
ADD:        strcat(s,") ");
EXIST:      strcat(s,(chains[map[i]].description));
EXIST:      pla(s,&abort);

     19) Replace the "void run_chain(int cn)" procedure with the  
   
         "GOLDSYS3.C" file
     20) Save the "BBSUTL1.C" file
     21) Load the "SYSOPF.C" file
     22) Do the following:

FIND:     extern unsigned char realsl;
ADD:      extern int rewardgold[64],costgold[64];

     23) Replace the "void boardedit()" procedure with the
"GOLDSYS4.C"
         file
     24) Replace the "void chainedit()" procedure with the
"GOLDSYS5.C"
         file
     29) At the very end of the "SYSOPF.C" file read in the
         "GOLDSYS2.C" file
     30) Save the "SYSOPF.C" file
     31) Load the "MSGBASE1.C" file
     32) Do the following:

FIND:     extern int checked[50];
ADD:      extern int rewardgold[64],costgold[64];

     33) Do the following:

FIND:     strcpy(s,"Posted on ");
EXIST:    strcat(s,subboards[curlsub].name);
EXIST:    save_status();
EXIST:    pl(s);
ADD:      goldload();
ADD:      thisuser.gold += rewardgold[curlsub];
ADD:      itoa(rewardgold[curlsub],s,10);
ADD:      nl();
ADD:      prt(3,"You receive ");
ADD:      prt(6,s);
ADD:      prt(3," gold for that post.");
ADD:      nl();
EXIST:    if ((subboards[curlsub].type) && (syscfg.systemnumber))
{

     34) Do the following:

FIND:         pl("Message removed.");
EXIST:        nl();
ADD:          goldload();
ADD:          thisuser.gold -= rewardgold[curlsub];
ADD:          itoa(rewardgold[curlsub],s,10);
ADD:          nl();
ADD:          prt(3,"You lost ");
ADD:          prt(6,s);
ADD:          prt(3," gold for removing that post.");
ADD:          nl();
EXIST:      }
EXIST:    }

     35) Save the "MSGBASE1.C" file
     36) Load the "BBSUTL.C" file (NEW IN VERSION 1.3)
     37) In "void yourinfo()" do the following:

FIND:       print("Time spent on  : ",s," Minutes","");
ADD:        itoa((int)thisuser.gold,s,10);
ADD:        print("Gold           : ",s,"");
EXIST:      nl();
EXIST:    }

     38) Save the "BBSUTL.C" file
     37) Compile WWIV and run


                              Further Information
                              -------------------
     If you have any problems installing or running this
modification, please contact me through the WWIVnet, or call my
bulletin board directly.  I would like to hear comments and/or
suggestions, so if you have them, I encourage you to send them.
Please remember to include the version of GoldSys that you are
using.


Tony Godfrey 1@18 "The Federation" (818) 407-0419

(*) May work with earlier or later versions of WWIV
