                            LOGOFF SEQUENCES MOD
                           BY SLICK THE SLICKSTER
                                   2/3/89

   This ARC file SLICK4.ARC, contains this file, SLICK4.MOD.

   This is a mod that will give your board a fancy logoff sequence.
This mod is suppose to count down from 10 to 1 upon logging off.  When
the count down reaches 1, the BBS will log the user off.  If the user
presses CTRL-X or SPACE BAR during the count down, it would ABORT on the
CTRL-X, and HANGUP the user immediately with the SPACE BAR.  This mod is
intended to be for the "O" command in the main menu, and transfer menu.
It can also be place in the batch downloading.

   The first thing you should do is read over this documentation throughly and
make sure you understand it.  Then you should install it using these
instructions.
                                 +------+
                                 | NOTE |
                                 +------+

   This mod contain some symbols, and may be mistaken as if it was the
included in the mod, please understand these symbols, before going on any
farther.
Ŀ
 LEGEND: * = Change Line 
         - = Delete Line 
         + = Add Line    

In some places, I might put this:
Ŀ
.
.
.

The first block, is the legend of the symbols.  The symbols will show up as
the first character on the line.  The second block is a group of three dots.
It means that the source code continues, and is not written in.  Usually, after
the three dots, there will be a piece of the source code which you can search
for, so when you find it.  You'll know where to continue.  Now let's start!!


                              [ F I R S T ]
                              [ B L O O D ]

Let's load up "FCNS.H" and insert this "int logoffmod();"
after "void prt(int i, char *s);"

Then load up "UTILITY.C" and add this function at the end of the file.

=============================[ CUT HERE ]==============================

int logoffmod()
{
   int i;
   unsigned char ch;

   nl();
   prt(2,"Log off Sequence");
   nl();
   prt(1,"Tap [Space Bar] to logoff.");
   nl();
   prt(1,"Tap [Ctrl-X] to abort.");
   nl();
   prt(3,"Disconnection in : ");
   prt(2,"0 1 2 3 4 5 6 7 8 9");
   i=1;
   ch=0;
   do
   {
      while (empty() && !hangup)
      {
         delay(1500);
         checkhangup();
         i+=1;
         if (i==20)
           return 1;
         outchr(8); outchr(32);
         outchr(8); outchr(32); outchr(8);
         outchr(7); outchr(7);
      }
      ch=inkey();
      if (ch==32)
        return 1;
      if (ch==24)
        return 0;
   } while (!hangup);
}


============================[ STOP CUTTING ]===========================


                             [ S E C O N D ]
                              [ B L O O D ]

After that, load up BBS.C and find "void mainmenu()" function.  Now
search for "case 'O':" and add/modify the following lines...
   void mainmenu()
   {
   .
   .
   .
     case 'O':
       nl();
       nl();
       prt(5,"Log Off? ");
       helpl=12;
       if (yn()) {
         outchr(12);
         print("Time on   = ",ctim(timer()-timeon),"");
+        if (logoffmod()==1)
+        {
+          nl(); nl();
+          sprintf(s1,"Goodbye %s...",thisuser.name);
+          prt(6,s1);
+          nl();
+          printfile("LOGOFF.MSG");
+          hangup=1;
+        }
-        printfile("LOGOFF.MSG");
-        hangup=1;
       }
       break;
     case 'P':
    .
    .
    .
    }

When you're done with the main menu, do the same with the "dlmainmenu"
function.  After that load up XFER.C and find "batchdl()" function and
add/modify the following lines...

    void batchdl()
    {
    .
    .
     .
         if (rr) {
           nl();
           pl("Your ratio is too low to continue the transfer.");
           nl();
         }
         if (had)
+          if (logoffmod()==1)
             hangup=1;
+        else
+          nl();
         done=1;
    .
    .
    .
    }

If you have Bilbo Baggins' batch protocols (ZMODEM/SUPERK8/JMODEM) mod
installed in your BBS already.  You must replace every:

     if (had)
       hangup=1;

     <<< TO >>>

     if (had)
       if (logoffmod()==1)
         hangup=1;
       else
         nl();

in every of external protocol case statement just like the original
YMODEM batch's.  I want to explain that the else statement after
hangup=1 is to insert a carrier return so that it would look neater when
the user aborts in the transfer.  I hope you enjoy this mod as much as I
have.  So, I'll see ya in the next releases of my mods.