Goose #19 @7313
Mon Jul 02 18:10:31 1990
                      Enhanced Message Quoting Mod               (MSGQUOTE.MOD)
                       by Goose, 1@7312 (WWIVnet)

Many BBS software programs these days offer a "quoting" feature when replying
messages, which provides a "> " at the beginning of each quoted line, plus
provides the quoted text after it.  For example, you would see a message like:

------------------------------------------------------------------------------

> How can I get rid of the DGROUP error in WWIV?  I've been modding my board
> and now I get that whenever I recompile.

A DGROUP error means that you've run out of variable space in the board.....

------------------------------------------------------------------------------

If you didn't already know what I was talking about, you should get the idea
by now.  What happens when you quote is the old message is read in, a "> " is
added to the beginning of each line, and you are put into the editor at the
bottom of the current message.  There has been at least one other mod that has
been released that is similar, but not quite as flexible as this one (it
doesn't use the quote ">" indicator, which makes the message a little
confusing, and it doesn't work with the internal editor).

OK, now for the first part of the mod.  Load up FCNS.H and make the following
one line addition (- indicates existing code, + indicates new/modified code):

- void grab_user_name(messagerec *m, char *fn);
+ void quote_message(messagerec *m1, char *aux);             /* mod - add */
- void scan(int msgnum, int optype, int *nextsub);
- void qscan(int bn, int *ns);

Now, go into MSGBASE1.C and find the void scan(....), and read in the following
code right before it.

+ void quote_message(messagerec *m1, char *aux)     /* mod - add entire void */
+ {
+   char *b,*c,s1[81];
+   int cc,dq,lc,f,ok;
+   long l,l1,l2;
+   messagerec m;
+
+   sprintf(s1,"%sINPUT.MSG",syscfg.tempdir);
+   if (exist(s1))
+     return;
+   nl();
+   prt(2,"Quote from message? ");
+   if (!yn())
+     return;
+   m=*m1;
+   b=readfile(&m,aux,&l);
+   if ((c=malloca(l+1000))==NULL) {
+     farfree(b);
+     return;
+   }
+   lc=0; l1=0; l2=0; ok=1;
+   do {
+     if (b[l1]==10)
+       lc++;
+     l1++;
+   } while (lc<2);
+   lc=0; dq=1; cc=48;
+   do {
+     if (lc==0) {
+       for (f=0; f<dq; f++) {
+         c[l2++]='>'; lc++;
+       }
+       if (dq==1) {
+         c[l2++]=' '; lc++;
+       }
+       if (cc!=48) {
+         c[l2++]=3;
+         c[l2++]=cc;
+       }
+     }
+     switch(b[l1]) {
+       case 3:
+         l1++;
+         cc=b[l1++];
+         c[l2++]=3;
+         c[l2++]=cc;
+         break;
+       case 1:
+         if (b[l1-1]!=32)
+           c[l2++]=' ';
+         l1+=3;
+         dq=1;
+         break;

(Continued...)