Parker Prospect #1 @9964
Thu May 31 22:11:13 1990
Mod Name        : Basic Message Quoting w/ FSEDs v1.2
Mod Filename    : QUOTE1_2.MOD
Mod Author      : Parker Prospect #1 @9964
Mod Description : I live in a small town, with relatively few BBSes (total
number = 5). Four of those are IBM BBSes, and one is SearchLight.  I am
quite taken with SearchLight, and love its editor to death.  One of the
features in this editor is the ability to "Get reply text".  What this does
is you press two keys (^KG) and the message you are replying to appears in
the editor, with quote characters '>' on the beginning of each line.  I
decided I wanted to do this, but it wouldn't be of real use unless you
could delete the unwanted lines.  Hence, the full-screen editor restriction
on quoting messages here (you need one in order to be able to edit it).
This works both locally and remotely, as long as the user supports a full
screen editor.

************** Legend **************
* %% Delete Line                   *
* -- Search for Line, DON'T CHANGE *
* ++ Add Line                      *
* -+ Modify Line                   *
* ## Line is part of another mod   *
************************************

------------------------------------------------------------------------
Step #1 <MSGBASE1.C>: In void scan, edit the code below as shown.

++              case 'A':
##                byline[0]=0;
++                if (okfsed()) {
++                  prt(2, "Quote from message? ");
++                  if (yn()) {
++                    if ((msgnum > 0) && (msgnum <= nummsgs)) {
++                      b = readfile(&(msgs[msgnum].msg),(subboards[curlsub].filename),&len);
++                      write_out_to_msg(b,len);
++                    }
++                    load_workspace("OUTPUT.MSG", 0);
++                    unlink("OUTPUT.MSG");
++                  }
++                }
--                if ((msgs[msgnum].ownersys) && (!msgs[msgnum].owneruser))
--                  grab_user_name(&(msgs[msgnum].msg),subboards[curlsub].filename);
--                ss=syscfg.sl[thisuser.sl];
--                if ((lcs()) || (ss.ability & ability_read_post_anony) || (msgs[msgnum].anony==0))
--                  email(msgs[msgnum].owneruser,msgs[msgnum].ownersys,0,0);
--                else
--                  email(msgs[msgnum].owneruser,msgs[msgnum].ownersys,0,msgs[msgnum].anony);
--                break;
--              case 'P':
##                byline[0]=0;
--                irt[0]=0;
--              case 'W':
--                deleted_flag = 0;
++                if (s[0] != 'P')
++                  if (okfsed()) {
++                    prt(2, "Quote from message? ");
++                    if (yn()) {
++                      if ((msgnum > 0) && (msgnum <= nummsgs)) {
++                        b = readfile(&(msgs[msgnum].msg),(subboards[curlsub].filename),&len);
++                        write_out_to_msg(b,len);
++                      }
++                      load_workspace("OUTPUT.MSG", 0);
++                      unlink("OUTPUT.MSG");
++                    }
++                  }
--                post();
--                if (deleted_flag && (deleted_flag<=msgnum))
--                  --msgnum;
--                break;

------------------------------------------------------------------------
Step #2 <MSGBASE1.C>: Add the following function BEFORE void scan.

void write_out_to_msg(char *b, long len)
{
  char s2[81];
  int i;

  sprintf(s2, "OUTPUT.MSG", syscfg.tempdir);
  i=open(s2,O_RDWR | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
  write(i,(void *)b,len);
  close(i);
  farfree(b);
}


------------------------------------------------------------------------
Step #3 <MSGBASE1.C>: Edit the following code in void readmail.

--            nl();
--          }
--          break;
--        case 'A':
--        case 'S':
##          byline[0]=0;
--          if (!okmail)
--            break;
--          close(f);
++          if (okfsed()) {
++            prt(2, "Quote from message? ");
++            if ((yn()) && (okmail)) {
++              b = readfile(&(m.msg),"EMAIL",&len);
++              write_out_to_msg(b,len);
++              load_workspace("OUTPUT.MSG", 0);
++              unlink("OUTPUT.MSG");
++            }
++          }
--          num_mail=((long) thisuser.feedbacksent) +
--                   ((long) thisuser.emailsent) +
--                   ((long) thisuser.emailnet);


------------------------------------------------------------------------
Final Step

Compile the BBS and update your menus to reflect the changes you made...


------------------------------------------------------------------------
Disclaimer

I, Jeff Garzik, claim no liability for this mod, or for any damage that
may have resulted from the use of this mod.  I also attach no warranty,
expressed OR implied, to this product.  This type of warranty and
liability disclaimer is prohibited by law in certain states, and is
therefore void in those states.

If you like this mod, you can call my board at:

  The East Carolina Connection
  919-756-2939 :::: 2400 baud MNP level 4
  24hrs a day -- 7 days a week
  Autovalidation of WWIV sysops (first call)

Thanks to Wayne Bell for writing such great software!